diff --git a/gcc/omp-low.c b/gcc/omp-low.c
index ddd2bd5..708fe48 100644
--- a/gcc/omp-low.c
+++ b/gcc/omp-low.c
@@ -10356,9 +10356,9 @@ static tree
 diagnose_sb_1 (gimple_stmt_iterator *gsi_p, bool *handled_ops_p,
     	       struct walk_stmt_info *wi)
 {
-  gimple context = (gimple) wi->info;
-  gimple inner_context;
-  gimple stmt = gsi_stmt (*gsi_p);
+  gimple *context = (gimple *) wi->info;
+  gimple *inner_context;
+  gimple *stmt = gsi_stmt (*gsi_p);
 
   *handled_ops_p = true;
 
@@ -10414,9 +10414,9 @@ static tree
 diagnose_sb_2 (gimple_stmt_iterator *gsi_p, bool *handled_ops_p,
     	       struct walk_stmt_info *wi)
 {
-  gimple context = (gimple) wi->info;
+  gimple *context = (gimple *) wi->info;
   splay_tree_node n;
-  gimple stmt = gsi_stmt (*gsi_p);
+  gimple *stmt = gsi_stmt (*gsi_p);
 
   *handled_ops_p = true;
 
@@ -10458,7 +10458,7 @@ diagnose_sb_2 (gimple_stmt_iterator *gsi_p, bool *handled_ops_p,
 	      n = splay_tree_lookup (all_labels,
 				     (splay_tree_key) lab);
 	      diagnose_sb_0 (gsi_p, context,
-			     n ? (gimple) n->value : NULL);
+			     n ? (gimple *) n->value : NULL);
 	    }
 	  lab = gimple_cond_false_label (stmt);
 	  if (lab)
@@ -10466,7 +10466,7 @@ diagnose_sb_2 (gimple_stmt_iterator *gsi_p, bool *handled_ops_p,
 	      n = splay_tree_lookup (all_labels,
 				     (splay_tree_key) lab);
 	      diagnose_sb_0 (gsi_p, context,
-			     n ? (gimple) n->value : NULL);
+			     n ? (gimple *) n->value : NULL);
 	    }
 	}
       break;
@@ -10478,7 +10478,7 @@ diagnose_sb_2 (gimple_stmt_iterator *gsi_p, bool *handled_ops_p,
 	  break;
 
 	n = splay_tree_lookup (all_labels, (splay_tree_key) lab);
-	diagnose_sb_0 (gsi_p, context, n ? (gimple) n->value : NULL);
+	diagnose_sb_0 (gsi_p, context, n ? (gimple *) n->value : NULL);
       }
       break;
 
@@ -10489,7 +10489,7 @@ diagnose_sb_2 (gimple_stmt_iterator *gsi_p, bool *handled_ops_p,
 	  {
 	    tree lab = CASE_LABEL (gimple_switch_label (stmt, i));
 	    n = splay_tree_lookup (all_labels, (splay_tree_key) lab);
-	    if (n && diagnose_sb_0 (gsi_p, context, (gimple) n->value))
+	    if (n && diagnose_sb_0 (gsi_p, context, (gimple *) n->value))
 	      break;
 	  }
       }
@@ -10512,7 +10512,7 @@ bool
 make_gimple_omp_edges (basic_block bb, struct omp_region **region,
 		       int *region_idx)
 {
-  gimple last = last_stmt (bb);
+  gimple *last = last_stmt (bb);
   enum gimple_code code = gimple_code (last);
   struct omp_region *cur_region = *region;
   bool fallthru = false;
@@ -11302,7 +11302,7 @@ simd_clone_init_simd_arrays (struct cgraph_node *node,
 
 struct modify_stmt_info {
   ipa_parm_adjustment_vec adjustments;
-  gimple stmt;
+  gimple *stmt;
   /* True if the parent statement was modified by
      ipa_simd_modify_stmt_ops.  */
   bool modified;
@@ -11356,7 +11356,7 @@ ipa_simd_modify_stmt_ops (tree *tp, int *walk_subtrees, void *data)
   if (tp != orig_tp)
     {
       repl = build_fold_addr_expr (repl);
-      gimple stmt
+      gimple *stmt
 	= gimple_build_assign (make_ssa_name (TREE_TYPE (repl), NULL), repl);
       repl = gimple_assign_lhs (stmt);
       gimple_stmt_iterator gsi = gsi_for_stmt (info->stmt);
@@ -11444,7 +11444,7 @@ ipa_simd_modify_function_body (struct cgraph_node *node,
 		    set_ssa_default_def (cfun, adjustments[j].base, NULL_TREE);
 		    SET_SSA_NAME_VAR_OR_IDENTIFIER (name, base_var);
 		    SSA_NAME_IS_DEFAULT_DEF (name) = 0;
-		    gimple stmt = gimple_build_assign (name, new_decl);
+		    gimple *stmt = gimple_build_assign (name, new_decl);
 		    gsi_insert_before (&gsi, stmt, GSI_SAME_STMT);
 		  }
 		else
@@ -11463,7 +11463,7 @@ ipa_simd_modify_function_body (struct cgraph_node *node,
       gsi = gsi_start_bb (bb);
       while (!gsi_end_p (gsi))
 	{
-	  gimple stmt = gsi_stmt (gsi);
+	  gimple *stmt = gsi_stmt (gsi);
 	  info.stmt = stmt;
 	  struct walk_stmt_info wi;
 
@@ -11552,7 +11552,7 @@ simd_clone_adjust (struct cgraph_node *node)
   edge e = make_edge (incr_bb, EXIT_BLOCK_PTR_FOR_FN (cfun), 0);
   e->probability = REG_BR_PROB_BASE;
   gsi = gsi_last_bb (incr_bb);
-  gimple g = gimple_build_assign_with_ops (PLUS_EXPR, iter2, iter1,
+  gimple *g = gimple_build_assign_with_ops (PLUS_EXPR, iter2, iter1,
 					   build_int_cst (unsigned_type_node,
 							  1));
   gsi_insert_after (&gsi, g, GSI_CONTINUE_LINKING);
@@ -11616,7 +11616,7 @@ simd_clone_adjust (struct cgraph_node *node)
      make_edge (incr_bb, latch_bb, EDGE_TRUE_VALUE);  */
   FALLTHRU_EDGE (incr_bb)->flags = EDGE_TRUE_VALUE;
 
-  gimple phi = create_phi_node (iter1, body_bb);
+  gimple *phi = create_phi_node (iter1, body_bb);
   edge preheader_edge = find_edge (entry_bb, body_bb);
   edge latch_edge = single_succ_edge (latch_bb);
   add_phi_arg (phi, build_zero_cst (unsigned_type_node), preheader_edge,
@@ -11659,7 +11659,7 @@ simd_clone_adjust (struct cgraph_node *node)
 	    tree fn = builtin_decl_explicit (BUILT_IN_ASSUME_ALIGNED);
 	    gimple_seq seq = NULL;
 	    bool need_cvt = false;
-	    gimple call
+	    gimple *call
 	      = gimple_build_call (fn, 2, def, size_int (alignment));
 	    g = call;
 	    if (!useless_type_conversion_p (TREE_TYPE (orig_arg),
@@ -11687,7 +11687,7 @@ simd_clone_adjust (struct cgraph_node *node)
 
 	    imm_use_iterator iter;
 	    use_operand_p use_p;
-	    gimple use_stmt;
+	    gimple *use_stmt;
 	    tree repl = gimple_get_lhs (g);
 	    FOR_EACH_IMM_USE_STMT (use_stmt, iter, def)
 	      if (is_gimple_debug (use_stmt) || use_stmt == call)
@@ -11723,7 +11723,7 @@ simd_clone_adjust (struct cgraph_node *node)
 
 	    imm_use_iterator iter;
 	    use_operand_p use_p;
-	    gimple use_stmt;
+	    gimple *use_stmt;
 	    FOR_EACH_IMM_USE_STMT (use_stmt, iter, def)
 	      if (use_stmt == phi)
 		continue;
diff --git a/gcc/passes.c b/gcc/passes.c
index 223b693..e003cd5 100644
--- a/gcc/passes.c
+++ b/gcc/passes.c
@@ -2595,7 +2595,7 @@ execute_ipa_pass_list (opt_pass *pass)
 
 static void
 execute_ipa_stmt_fixups (opt_pass *pass,
-			 struct cgraph_node *node, gimple *stmts)
+			 struct cgraph_node *node, gimple **stmts)
 {
   while (pass)
     {
@@ -2629,7 +2629,7 @@ execute_ipa_stmt_fixups (opt_pass *pass,
 /* Execute stmt fixup hooks of all IPA passes for NODE and STMTS.  */
 
 void
-execute_all_ipa_stmt_fixups (struct cgraph_node *node, gimple *stmts)
+execute_all_ipa_stmt_fixups (struct cgraph_node *node, gimple **stmts)
 {
   pass_manager *passes = g->get_passes ();
   execute_ipa_stmt_fixups (passes->all_regular_ipa_passes, node, stmts);
diff --git a/gcc/predict.c b/gcc/predict.c
index 165cc4e..9ebb7d2 100644
--- a/gcc/predict.c
+++ b/gcc/predict.c
@@ -1107,7 +1107,7 @@ get_base_value (tree t)
    Otherwise return false and set LOOP_INVAIANT to NULL.  */
 
 static bool
-is_comparison_with_loop_invariant_p (gimple stmt, struct loop *loop,
+is_comparison_with_loop_invariant_p (gimple *stmt, struct loop *loop,
 				     tree *loop_invariant,
 				     enum tree_code *compare_code,
 				     tree *loop_step,
@@ -1194,7 +1194,7 @@ is_comparison_with_loop_invariant_p (gimple stmt, struct loop *loop,
 static bool
 expr_coherent_p (tree t1, tree t2)
 {
-  gimple stmt;
+  gimple *stmt;
   tree ssa_name_1 = NULL;
   tree ssa_name_2 = NULL;
 
@@ -1257,7 +1257,7 @@ predict_iv_comparison (struct loop *loop, basic_block bb,
 		       enum tree_code loop_bound_code,
 		       int loop_bound_step)
 {
-  gimple stmt;
+  gimple *stmt;
   tree compare_var, compare_base;
   enum tree_code compare_code;
   tree compare_step_var;
@@ -1445,9 +1445,9 @@ predict_extra_loop_exits (edge exit_edge)
 {
   unsigned i;
   bool check_value_one;
-  gimple phi_stmt;
+  gimple *phi_stmt;
   tree cmp_rhs, cmp_lhs;
-  gimple cmp_stmt = last_stmt (exit_edge->src);
+  gimple *cmp_stmt = last_stmt (exit_edge->src);
 
   if (!cmp_stmt || gimple_code (cmp_stmt) != GIMPLE_COND)
     return;
@@ -1513,7 +1513,7 @@ predict_loops (void)
       tree loop_bound_step = NULL;
       tree loop_bound_var = NULL;
       tree loop_iv_base = NULL;
-      gimple stmt = NULL;
+      gimple *stmt = NULL;
 
       exits = get_loop_exit_edges (loop);
       n_exits = exits.length ();
@@ -1780,7 +1780,7 @@ static tree
 expr_expected_value_1 (tree type, tree op0, enum tree_code code,
 		       tree op1, bitmap visited, enum br_predictor *predictor)
 {
-  gimple def;
+  gimple *def;
 
   if (predictor)
     *predictor = PRED_UNCONDITIONAL;
@@ -1974,7 +1974,7 @@ expr_expected_value (tree expr, bitmap visited,
 static void
 tree_predict_by_opcode (basic_block bb)
 {
-  gimple stmt = last_stmt (bb);
+  gimple *stmt = last_stmt (bb);
   edge then_edge;
   tree op0, op1;
   tree type;
@@ -2142,10 +2142,10 @@ return_prediction (tree val, enum prediction *prediction)
 static void
 apply_return_prediction (void)
 {
-  gimple return_stmt = NULL;
+  gimple *return_stmt = NULL;
   tree return_val;
   edge e;
-  gimple phi;
+  gimple *phi;
   int phi_num_args, i;
   enum br_predictor pred;
   enum prediction direction;
@@ -2214,7 +2214,7 @@ tree_bb_level_predictions (void)
 
       for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	{
-	  gimple stmt = gsi_stmt (gsi);
+	  gimple *stmt = gsi_stmt (gsi);
 	  tree decl;
 
 	  if (is_gimple_call (stmt))
@@ -2262,7 +2262,7 @@ tree_estimate_probability_bb (basic_block bb)
 {
   edge e;
   edge_iterator ei;
-  gimple last;
+  gimple *last;
 
   FOR_EACH_EDGE (e, ei, bb->succs)
     {
@@ -2272,7 +2272,7 @@ tree_estimate_probability_bb (basic_block bb)
 	  gimple_stmt_iterator gi;
 	  for (gi = gsi_start_bb (e->dest); !gsi_end_p (gi); gsi_next (&gi))
 	    {
-	      gimple stmt = gsi_stmt (gi);
+	      gimple *stmt = gsi_stmt (gi);
 	      tree decl;
 
 	      if (gimple_code (stmt) != GIMPLE_LABEL)
@@ -2344,7 +2344,7 @@ tree_estimate_probability_bb (basic_block bb)
 	  for (bi = gsi_start_bb (e->dest); !gsi_end_p (bi);
 	       gsi_next (&bi))
 	    {
-	      gimple stmt = gsi_stmt (bi);
+	      gimple *stmt = gsi_stmt (bi);
 	      if (is_gimple_call (stmt)
 		  /* Constant and pure calls are hardly used to signalize
 		     something exceptional.  */
@@ -3148,7 +3148,7 @@ unsigned int
 pass_strip_predict_hints::execute (function *fun)
 {
   basic_block bb;
-  gimple ass_stmt;
+  gimple *ass_stmt;
   tree var;
 
   FOR_EACH_BB_FN (bb, fun)
@@ -3156,7 +3156,7 @@ pass_strip_predict_hints::execute (function *fun)
       gimple_stmt_iterator bi;
       for (bi = gsi_start_bb (bb); !gsi_end_p (bi);)
 	{
-	  gimple stmt = gsi_stmt (bi);
+	  gimple *stmt = gsi_stmt (bi);
 
 	  if (gimple_code (stmt) == GIMPLE_PREDICT)
 	    {
diff --git a/gcc/profile.c b/gcc/profile.c
index 83cbc07..46121d1 100644
--- a/gcc/profile.c
+++ b/gcc/profile.c
@@ -896,7 +896,7 @@ compute_value_histograms (histogram_values values, unsigned cfg_checksum,
   for (i = 0; i < values.length (); i++)
     {
       histogram_value hist = values[i];
-      gimple stmt = hist->hvalue.stmt;
+      gimple *stmt = hist->hvalue.stmt;
 
       t = (int) hist->type;
 
@@ -1037,7 +1037,7 @@ branch_prob (void)
       FOR_EACH_EDGE (e, ei, bb->succs)
 	{
 	  gimple_stmt_iterator gsi;
-	  gimple last = NULL;
+	  gimple *last = NULL;
 
 	  /* It may happen that there are compiler generated statements
 	     without a locus at all.  Go through the basic block from the
@@ -1103,7 +1103,7 @@ branch_prob (void)
 	  if (have_exit_edge || need_exit_edge)
 	    {
 	      gimple_stmt_iterator gsi;
-	      gimple first;
+	      gimple *first;
 
 	      gsi = gsi_start_nondebug_after_labels_bb (bb);
 	      gcc_checking_assert (!gsi_end_p (gsi));
@@ -1266,7 +1266,7 @@ branch_prob (void)
 
 	  for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
 	    {
-	      gimple stmt = gsi_stmt (gsi);
+	      gimple *stmt = gsi_stmt (gsi);
 	      if (gimple_has_location (stmt))
 		output_location (gimple_filename (stmt), gimple_lineno (stmt),
 				 &offset, bb);
diff --git a/gcc/sese.c b/gcc/sese.c
index 342c5e8..ae98c35 100644
--- a/gcc/sese.c
+++ b/gcc/sese.c
@@ -227,7 +227,7 @@ sese_build_liveouts_bb (sese region, bitmap liveouts, basic_block bb)
 
   for (bsi = gsi_start_bb (bb); !gsi_end_p (bsi); gsi_next (&bsi))
     {
-      gimple stmt = gsi_stmt (bsi);
+      gimple *stmt = gsi_stmt (bsi);
 
       if (is_gimple_debug (stmt))
 	continue;
@@ -279,7 +279,7 @@ sese_reset_debug_liveouts_bb (sese region, bitmap liveouts, basic_block bb)
 
   for (bsi = gsi_start_bb (bb); !gsi_end_p (bsi); gsi_next (&bsi))
     {
-      gimple stmt = gsi_stmt (bsi);
+      gimple *stmt = gsi_stmt (bsi);
 
       if (!is_gimple_debug (stmt))
 	continue;
@@ -346,7 +346,7 @@ free_sese (sese region)
 static void
 sese_add_exit_phis_edge (basic_block exit, tree use, edge false_e, edge true_e)
 {
-  gimple phi = create_phi_node (NULL_TREE, exit);
+  gimple *phi = create_phi_node (NULL_TREE, exit);
   create_new_def_for (use, phi, gimple_phi_result_ptr (phi));
   add_phi_arg (phi, use, false_e, UNKNOWN_LOCATION);
   add_phi_arg (phi, use, true_e, UNKNOWN_LOCATION);
@@ -461,7 +461,7 @@ set_rename (rename_map_type rename_map, tree old_name, tree expr)
    is set when the code generation cannot continue.  */
 
 static bool
-rename_uses (gimple copy, rename_map_type rename_map,
+rename_uses (gimple *copy, rename_map_type rename_map,
 	     gimple_stmt_iterator *gsi_tgt,
 	     sese region, loop_p loop, vec<tree> iv_map,
 	     bool *gloog_error)
@@ -580,8 +580,8 @@ graphite_copy_stmts_from_block (basic_block bb, basic_block new_bb,
     {
       def_operand_p def_p;
       ssa_op_iter op_iter;
-      gimple stmt = gsi_stmt (gsi);
-      gimple copy;
+      gimple *stmt = gsi_stmt (gsi);
+      gimple *copy;
       tree lhs;
 
       /* Do not copy labels or conditions.  */
@@ -781,9 +781,9 @@ set_ifsese_condition (ifsese if_region, tree condition)
   sese region = if_region->region;
   edge entry = region->entry;
   basic_block bb = entry->dest;
-  gimple last = last_stmt (bb);
+  gimple *last = last_stmt (bb);
   gimple_stmt_iterator gsi = gsi_last_bb (bb);
-  gimple cond_stmt;
+  gimple *cond_stmt;
 
   gcc_assert (gimple_code (last) == GIMPLE_COND);
 
@@ -802,7 +802,7 @@ set_ifsese_condition (ifsese if_region, tree condition)
 tree
 scalar_evolution_in_region (sese region, loop_p loop, tree t)
 {
-  gimple def;
+  gimple *def;
   struct loop *def_loop;
   basic_block before = block_before_sese (region);
 
diff --git a/gcc/sese.h b/gcc/sese.h
index af919f8..c7da73a 100644
--- a/gcc/sese.h
+++ b/gcc/sese.h
@@ -114,7 +114,7 @@ bb_in_sese_p (basic_block bb, sese region)
 /* Returns true when STMT is defined in REGION.  */
 
 static inline bool
-stmt_in_sese_p (gimple stmt, sese region)
+stmt_in_sese_p (gimple *stmt, sese region)
 {
   basic_block bb = gimple_bb (stmt);
   return bb && bb_in_sese_p (bb, region);
@@ -125,7 +125,7 @@ stmt_in_sese_p (gimple stmt, sese region)
 static inline bool
 defined_in_sese_p (tree name, sese region)
 {
-  gimple stmt = SSA_NAME_DEF_STMT (name);
+  gimple *stmt = SSA_NAME_DEF_STMT (name);
   return stmt_in_sese_p (stmt, region);
 }
 
@@ -309,8 +309,8 @@ typedef struct gimple_bb
      corresponding element in CONDITION_CASES is not NULL_TREE.  For a
      SWITCH_EXPR the corresponding element in CONDITION_CASES is a
      CASE_LABEL_EXPR.  */
-  vec<gimple> conditions;
-  vec<gimple> condition_cases;
+  vec<gimple *> conditions;
+  vec<gimple *> condition_cases;
   vec<data_reference_p> data_refs;
 } *gimple_bb_p;
 
diff --git a/gcc/ssa-iterators.h b/gcc/ssa-iterators.h
index 2c75e4a..0c60fd0 100644
--- a/gcc/ssa-iterators.h
+++ b/gcc/ssa-iterators.h
@@ -116,7 +116,7 @@ struct imm_use_iterator
 
 extern bool has_zero_uses_1 (const ssa_use_operand_t *head);
 extern bool single_imm_use_1 (const ssa_use_operand_t *head,
-			      use_operand_p *use_p, gimple *stmt);
+			      use_operand_p *use_p, gimple **stmt);
 
 
 enum ssa_op_iter_type {
@@ -139,7 +139,7 @@ struct ssa_op_iter
   unsigned i;
   unsigned numops;
   use_optype_p uses;
-  gimple stmt;
+  gimple *stmt;
 };
 
 /* NOTE: Keep these in sync with doc/tree-ssa.texi.  */
@@ -288,7 +288,7 @@ set_ssa_use_from_ptr (use_operand_p use, tree val)
 /* Link ssa_imm_use node LINKNODE into the chain for DEF, with use occurring
    in STMT.  */
 static inline void
-link_imm_use_stmt (ssa_use_operand_t *linknode, tree def, gimple stmt)
+link_imm_use_stmt (ssa_use_operand_t *linknode, tree def, gimple *stmt)
 {
   if (stmt)
     link_imm_use (linknode, def);
@@ -318,7 +318,7 @@ relink_imm_use (ssa_use_operand_t *node, ssa_use_operand_t *old)
    in STMT.  */
 static inline void
 relink_imm_use_stmt (ssa_use_operand_t *linknode, ssa_use_operand_t *old,
-		     gimple stmt)
+		     gimple *stmt)
 {
   if (stmt)
     relink_imm_use (linknode, old);
@@ -414,7 +414,7 @@ has_single_use (const_tree var)
 /* If VAR has only a single immediate nondebug use, return true, and
    set USE_P and STMT to the use pointer and stmt of occurrence.  */
 static inline bool
-single_imm_use (const_tree var, use_operand_p *use_p, gimple *stmt)
+single_imm_use (const_tree var, use_operand_p *use_p, gimple **stmt)
 {
   const ssa_use_operand_t *const ptr = &(SSA_NAME_IMM_USE_NODE (var));
 
@@ -592,7 +592,7 @@ clear_and_done_ssa_iter (ssa_op_iter *ptr)
 
 /* Initialize the iterator PTR to the virtual defs in STMT.  */
 static inline void
-op_iter_init (ssa_op_iter *ptr, gimple stmt, int flags)
+op_iter_init (ssa_op_iter *ptr, gimple *stmt, int flags)
 {
   /* PHI nodes require a different iterator initialization path.  We
      do not support iterating over virtual defs or uses without
@@ -633,7 +633,7 @@ op_iter_init (ssa_op_iter *ptr, gimple stmt, int flags)
 /* Initialize iterator PTR to the use operands in STMT based on FLAGS. Return
    the first use.  */
 static inline use_operand_p
-op_iter_init_use (ssa_op_iter *ptr, gimple stmt, int flags)
+op_iter_init_use (ssa_op_iter *ptr, gimple *stmt, int flags)
 {
   gcc_checking_assert ((flags & SSA_OP_ALL_DEFS) == 0
 		       && (flags & SSA_OP_USE));
@@ -645,7 +645,7 @@ op_iter_init_use (ssa_op_iter *ptr, gimple stmt, int flags)
 /* Initialize iterator PTR to the def operands in STMT based on FLAGS. Return
    the first def.  */
 static inline def_operand_p
-op_iter_init_def (ssa_op_iter *ptr, gimple stmt, int flags)
+op_iter_init_def (ssa_op_iter *ptr, gimple *stmt, int flags)
 {
   gcc_checking_assert ((flags & SSA_OP_ALL_USES) == 0
 		       && (flags & SSA_OP_DEF));
@@ -657,7 +657,7 @@ op_iter_init_def (ssa_op_iter *ptr, gimple stmt, int flags)
 /* Initialize iterator PTR to the operands in STMT based on FLAGS. Return
    the first operand as a tree.  */
 static inline tree
-op_iter_init_tree (ssa_op_iter *ptr, gimple stmt, int flags)
+op_iter_init_tree (ssa_op_iter *ptr, gimple *stmt, int flags)
 {
   op_iter_init (ptr, stmt, flags);
   ptr->iter_type = ssa_op_iter_tree;
@@ -668,7 +668,7 @@ op_iter_init_tree (ssa_op_iter *ptr, gimple stmt, int flags)
 /* If there is a single operand in STMT matching FLAGS, return it.  Otherwise
    return NULL.  */
 static inline tree
-single_ssa_tree_operand (gimple stmt, int flags)
+single_ssa_tree_operand (gimple *stmt, int flags)
 {
   tree var;
   ssa_op_iter iter;
@@ -686,7 +686,7 @@ single_ssa_tree_operand (gimple stmt, int flags)
 /* If there is a single operand in STMT matching FLAGS, return it.  Otherwise
    return NULL.  */
 static inline use_operand_p
-single_ssa_use_operand (gimple stmt, int flags)
+single_ssa_use_operand (gimple *stmt, int flags)
 {
   use_operand_p var;
   ssa_op_iter iter;
@@ -705,7 +705,7 @@ single_ssa_use_operand (gimple stmt, int flags)
 /* If there is a single operand in STMT matching FLAGS, return it.  Otherwise
    return NULL.  */
 static inline def_operand_p
-single_ssa_def_operand (gimple stmt, int flags)
+single_ssa_def_operand (gimple *stmt, int flags)
 {
   def_operand_p var;
   ssa_op_iter iter;
@@ -723,7 +723,7 @@ single_ssa_def_operand (gimple stmt, int flags)
 /* Return true if there are zero operands in STMT matching the type
    given in FLAGS.  */
 static inline bool
-zero_ssa_operands (gimple stmt, int flags)
+zero_ssa_operands (gimple *stmt, int flags)
 {
   ssa_op_iter iter;
 
@@ -734,7 +734,7 @@ zero_ssa_operands (gimple stmt, int flags)
 
 /* Return the number of operands matching FLAGS in STMT.  */
 static inline int
-num_ssa_operands (gimple stmt, int flags)
+num_ssa_operands (gimple *stmt, int flags)
 {
   ssa_op_iter iter;
   tree t;
@@ -749,7 +749,7 @@ num_ssa_operands (gimple stmt, int flags)
 /* If there is a single DEF in the PHI node which matches FLAG, return it.
    Otherwise return NULL_DEF_OPERAND_P.  */
 static inline tree
-single_phi_def (gimple stmt, int flags)
+single_phi_def (gimple *stmt, int flags)
 {
   tree def = PHI_RESULT (stmt);
   if ((flags & SSA_OP_DEF) && is_gimple_reg (def))
@@ -762,7 +762,7 @@ single_phi_def (gimple stmt, int flags)
 /* Initialize the iterator PTR for uses matching FLAGS in PHI.  FLAGS should
    be either SSA_OP_USES or SSA_OP_VIRTUAL_USES.  */
 static inline use_operand_p
-op_iter_init_phiuse (ssa_op_iter *ptr, gimple phi, int flags)
+op_iter_init_phiuse (ssa_op_iter *ptr, gimple *phi, int flags)
 {
   tree phi_def = gimple_phi_result (phi);
   int comp;
@@ -792,7 +792,7 @@ op_iter_init_phiuse (ssa_op_iter *ptr, gimple phi, int flags)
 /* Start an iterator for a PHI definition.  */
 
 static inline def_operand_p
-op_iter_init_phidef (ssa_op_iter *ptr, gimple phi, int flags)
+op_iter_init_phidef (ssa_op_iter *ptr, gimple *phi, int flags)
 {
   tree phi_def = PHI_RESULT (phi);
   int comp;
@@ -873,7 +873,7 @@ link_use_stmts_after (use_operand_p head, imm_use_iterator *imm)
 {
   use_operand_p use_p;
   use_operand_p last_p = head;
-  gimple head_stmt = USE_STMT (head);
+  gimple *head_stmt = USE_STMT (head);
   tree use = USE_FROM_PTR (head);
   ssa_op_iter op_iter;
   int flag;
@@ -908,7 +908,7 @@ link_use_stmts_after (use_operand_p head, imm_use_iterator *imm)
 }
 
 /* Initialize IMM to traverse over uses of VAR.  Return the first statement.  */
-static inline gimple
+static inline gimple *
 first_imm_use_stmt (imm_use_iterator *imm, tree var)
 {
   imm->end_p = &(SSA_NAME_IMM_USE_NODE (var));
@@ -933,7 +933,7 @@ first_imm_use_stmt (imm_use_iterator *imm, tree var)
 
 /* Bump IMM to the next stmt which has a use of var.  */
 
-static inline gimple
+static inline gimple *
 next_imm_use_stmt (imm_use_iterator *imm)
 {
   imm->imm_use = imm->iter_node.next;
@@ -983,7 +983,7 @@ next_imm_use_on_stmt (imm_use_iterator *imm)
 
 /* Delink all immediate_use information for STMT.  */
 static inline void
-delink_stmt_imm_use (gimple stmt)
+delink_stmt_imm_use (gimple *stmt)
 {
    ssa_op_iter iter;
    use_operand_p use_p;
diff --git a/gcc/stmt.c b/gcc/stmt.c
index 163d495..23da44a 100644
--- a/gcc/stmt.c
+++ b/gcc/stmt.c
@@ -1130,7 +1130,7 @@ reset_out_edges_aux (basic_block bb)
    STMT. Record this information in the aux field of the edge.  */
 
 static inline void
-compute_cases_per_edge (gimple stmt)
+compute_cases_per_edge (gimple *stmt)
 {
   basic_block bb = gimple_bb (stmt);
   reset_out_edges_aux (bb);
@@ -1152,7 +1152,7 @@ compute_cases_per_edge (gimple stmt)
    Generate the code to test it and jump to the right place.  */
 
 void
-expand_case (gimple stmt)
+expand_case (gimple *stmt)
 {
   tree minval = NULL_TREE, maxval = NULL_TREE, range = NULL_TREE;
   rtx default_label = NULL_RTX;
diff --git a/gcc/tracer.c b/gcc/tracer.c
index 16c6949..c1017d0 100644
--- a/gcc/tracer.c
+++ b/gcc/tracer.c
@@ -93,7 +93,7 @@ bb_seen_p (basic_block bb)
 static bool
 ignore_bb_p (const_basic_block bb)
 {
-  gimple g;
+  gimple *g;
 
   if (bb->index < NUM_FIXED_BLOCKS)
     return true;
@@ -115,7 +115,7 @@ static int
 count_insns (basic_block bb)
 {
   gimple_stmt_iterator gsi;
-  gimple stmt;
+  gimple *stmt;
   int n = 0;
 
   for (gsi = gsi_start_bb (bb); !gsi_end_p (gsi); gsi_next (&gsi))
